import java.io.*;
import java.lang.reflect.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

class MyClientThread extends Thread {
	
	private Socket socket;
	private String serverAddr;
	private String username;
	private int serverPort;
	private BufferedReader in;
   private static PrintWriter out;

	public MyClientThread (String serverAddr, String serverPort, String username){
		
		try{
			this.serverPort = Integer.parseInt(serverPort);
			this.serverAddr = serverAddr;
			this.username = username;
		}catch(Exception e){
			JOptionPane.showMessageDialog(null, "Puerto ingresado no vlido.\n"+e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
			return;
		}
		try{
			socket = new Socket(this.serverAddr, this.serverPort);	//Conexion al servidor

         out = new PrintWriter(socket.getOutputStream(), true);	// Salida hacia el servidor
         in = new BufferedReader(new	
            InputStreamReader(socket.getInputStream()));	// Entrada desde el servidor
		}catch(Exception e){
			JOptionPane.showMessageDialog(null, "Error al conectarse al servidor.\n"+e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
			return;
		}
		JOptionPane.showMessageDialog(null, "Conexion establecida con el servidor.", "Info", JOptionPane.INFORMATION_MESSAGE);
	}
	public void run(){
		try{
			out.println(username);	//Enviar username al server
			
			String line = "";	
			line = in.readLine();
			
			if( line.compareTo("NA") == 0){
				JOptionPane.showMessageDialog(null, "Se super el lmite de usuarios. Desconectado del servidor", "Info", JOptionPane.INFORMATION_MESSAGE);
				return;
			}
			
			int my_index = Integer.parseInt(line);		
			TextEditorGUI.setHostType("CLIENT", my_index);

			//Recibir el username de todos los clientes conectados
			int i = 1;
			while( true ){
				line = in.readLine();
		      if (line != null){
					if(line.compareTo("ENDLOAD")!=0){
						TextEditorGUI.addInSidebar(line, i);
					}else break;
				}
				i++;
			}
			//Recibir el texto compartido
			TextEditorGUI.documentListenerOFF();
			TextEditorGUI.getTextArea().setText("");
			while( true ){
				line = in.readLine();
		      if (line != null){
					if(line.compareTo("ENDLOAD")!=0){
						TextEditorGUI.addText(line, -1, 0);
			 			TextEditorGUI.addText("\n", -1, 0);
					}else break;
				}
			}
			
			TextEditorGUI.removeText(TextEditorGUI.getTextArea().getDocument().getLength()-1, 1);
			TextEditorGUI.documentListenerON();
			while(true){	
			
	      	int position = Integer.parseInt(in.readLine());
	      	line = in.readLine();	//Esperar hasta recibir
				
				TextEditorGUI.documentListenerOFF();
				if( line.compareTo("I") == 0 ){
					int client_index = Integer.parseInt(in.readLine());		
				  	TextEditorGUI.addText((char)in.read()+"", position, client_index);
				}
				if( line.compareTo("R") == 0 ){
					int length = Integer.parseInt(in.readLine());
				  	TextEditorGUI.removeText(position, length);
				}
				if( line.compareTo("N") == 0 ){	//Nuevo Cliente
					String username = in.readLine();
					TextEditorGUI.addInSidebar( username, Integer.parseInt(in.readLine()));
				}
				if( line.compareTo("D") == 0 ){	//Desconexion Cliente
					String username = in.readLine();
					if( username.compareTo(this.username) == 0){
						socket.close();
						TextEditorGUI.removeFromSidebar("ALL");
					}
					TextEditorGUI.removeFromSidebar( username );
				}	
				TextEditorGUI.documentListenerON();
			}
		}catch(Exception E){
			System.out.println("(10)"+E.toString());
			TextEditorGUI.setHostType("No conectado", 0);
			return;
		}
	}
	public static void sendToServer(char input, int position, int length, String type){
	
		out.println(position+"");
		if( type == "INSERT" ){
			out.println("I");
			out.print(input);
			out.flush();
		}	
		if( type == "REMOVE" ){
			out.println("R");
			out.println(length+"");	
		}					
	}
}