import java.io.*;
import java.lang.*;
import java.net.*;
import java.util.*;
import javax.swing.*;

class MyServerThread extends Thread {

	private ServerSocket socket;
	private int port;
	private static int maxClients;
	private static int nClients = 1;
	private static Vector<PrintWriter> outToClient = new Vector<PrintWriter>();
	private static Vector<String> clientsUsername = new Vector<String>();

	public MyServerThread (String port, String maxClients){
		
		try{
			this.port = Integer.parseInt(port);
			this.maxClients = Integer.parseInt(maxClients);
		}catch(Exception e){
			JOptionPane.showMessageDialog(null, "Datos ingresados no vlidos.\n"+e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
			return;
		}
		try{
			socket = new ServerSocket(this.port);
		}catch(Exception e){
			JOptionPane.showMessageDialog(null, "Error al crear servidor.\n"+e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
			return;
		}
		JOptionPane.showMessageDialog(null, "Servidor creado.", "Info", JOptionPane.INFORMATION_MESSAGE);
		TextEditorGUI.getTextArea().setEditable(false);
		TextEditorGUI.setHostType("SERVER", 0);
	}
	public void run(){

		int i = 1;
      for (;;){  
			try{
				if(socket != null){
			      final Socket incoming = socket.accept();	// Esperar por clientes
					final int client_index = i;
			      System.out.println("Conexion de cliente: " + i);
					
					BufferedReader in = new BufferedReader(new	
            		InputStreamReader(incoming.getInputStream()));
					PrintWriter out = new PrintWriter
	            	(incoming.getOutputStream(), true /* autoFlush */);//Salida
										
					//Recibir username del nuevo cliente
					final String username = in.readLine();
					
					if( nClients <= maxClients ){
						TextEditorGUI.addInSidebar(username, client_index);
						
						//Enviar index de cliente nuevo a este
						out.println(client_index);
						
						//Avisar a todo el resto del nuevo cliente
						Iterator iter = outToClient.iterator();
						while(iter.hasNext()){	// Mientras no se haya recorrido el vector por completo
							PrintWriter toClients = (PrintWriter) iter.next();
							try{
								toClients.println("0"); //Debido a que se usa el mismo metodo receptor de caracteres
																//en el cliente, este espera por la posicion. Se enva cualquier n.
								toClients.println("N");
								toClients.println(username);
								toClients.println(client_index);
							}catch(Exception e){
								System.out.println("(5)"+e.toString());
							}
						}
						//Se agrega al vector de clientes
						outToClient.add(out);
						clientsUsername.add(username);
						
						for( int j=0; j< clientsUsername.size();j++)
							out.println(clientsUsername.elementAt(j));
						out.println("ENDLOAD");
						
						out.println(TextEditorGUI.getTextArea().getText());
						out.println("ENDLOAD");
						i++;
						Thread inThread = new Thread(){
	                     public void run(){
									receive(incoming, client_index, username);
	                     }
	                  };
						inThread.start();
						nClients++;
					}else{
						out.println("NA");	//No aceptado, mayor al lmite de clientes
					}
						
				}else return;
			}catch(Exception e){
				JOptionPane.showMessageDialog(null, "Error al aceptar clientes.\n"+e.toString(), "Error", JOptionPane.ERROR_MESSAGE);
			}
      }

	}
	public void receive(Socket incoming, int client_index, String username){
		try{
			BufferedReader in = new BufferedReader(new	
            		InputStreamReader(incoming.getInputStream()));
			
	     	while(true){
	      	int position = Integer.parseInt(in.readLine());
	      	String line = in.readLine();	//Esperar hasta recibir		
				if( line.compareTo("I") == 0 ){
					char input = (char)in.read();			
				  	TextEditorGUI.addText(input+"", position, client_index);
					sendToAll(input, position, 0, "INSERT", client_index);
				}
				if( line.compareTo("R") == 0 ){
					int length = Integer.parseInt(in.readLine());
				  	TextEditorGUI.removeText(position, length);
					sendToAll((char)0, position, length, "REMOVE", client_index);
				}
				
			}
		}catch(Exception E){
			//System.out.println("(6)"+E.toString());
			try{
			TextEditorGUI.removeFromSidebar(username);
			//Avisar a todo el resto de la desconexion del cliente
			Iterator iter = outToClient.iterator();
			while(iter.hasNext()){	// Mientras no se haya recorrido el vector por completo	
				PrintWriter toClients = (PrintWriter) iter.next();
				
					toClients.println("0"); //Debido a que se usa el mismo metodo receptor de caracteres
													//en el cliente, este espera por la posicion. Se enva cualquier n.
					toClients.println("D");
					toClients.println(username);
						
			}
			/*
			iter = outToClient.iterator();
			while(iter.hasNext()){
				PrintWriter toClients = (PrintWriter) iter.next();
				if(toClients.equals((PrintWriter)outToClient.elementAt(client_index-1))){
					outToClient.remove(toClients);
					break;
				}
			}*/
			nClients--;
			clientsUsername.setElementAt("", clientsUsername.indexOf(username));
			}catch(Exception e){
				//System.out.println("(7)"+e.toString());
			}
		}
	}
	public static synchronized void sendToAll(char input, int position, int length, String type, int client_index){
		Iterator iter = outToClient.iterator();
		while(iter.hasNext()){	// Mientras no se haya recorrido el vector por completo
			PrintWriter toClients = (PrintWriter) iter.next();
			if(!toClients.equals((PrintWriter)outToClient.elementAt(client_index-1))){	//a todos menos al que envi
				try{
					toClients.println(position+"");
					if( type == "INSERT" ){
						toClients.println("I");
						toClients.println(client_index);
						toClients.print(input);
						toClients.flush();
					}	
					if( type == "REMOVE" ){
						toClients.println("R");
						toClients.println(length+"");	
					}
				}catch(Exception ex){
					System.out.println("(8)"+ex.toString());
				}
			}
		}				
	}
	public static void disconnectClient(String username, int client_index){
		System.out.println(username+" disconnected.");
		try{
			//Avisar a todo el resto de la desconexion del cliente
			Iterator iter = outToClient.iterator();
			while(iter.hasNext()){	// Mientras no se haya recorrido el vector por completo	
				PrintWriter toClients = (PrintWriter) iter.next();
				try{
					toClients.println("0"); //Debido a que se usa el mismo metodo receptor de caracteres
													//en el cliente, este espera por la posicion. Se enva cualquier n.
					toClients.println("D");
					toClients.println(username);
				}catch(Exception e){
					System.out.println("(9)"+e.toString());
				}		
			}
			nClients--;
			clientsUsername.setElementAt("", clientsUsername.indexOf(username));
			
			TextEditorGUI.removeFromSidebar(username);
		}catch(Exception ex){}
	}	
}