   import javax.swing.*;
   import javax.swing.border.*;
   import javax.swing.event.*;
   import javax.swing.filechooser.*;
   import javax.swing.text.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.io.*;
   import java.lang.reflect.*;
   import java.util.*;

   public class TextEditorGUI extends JFrame{
   
      private static JPanel sidebar;
      private static MyTextPane textArea;
      private static String hostType = "";
      private static MyDocumentListener documentListener;
      private static Color colorArray[] = {Color.BLACK, Color.RED,Color.BLUE,Color.GREEN,Color.PINK,
         										Color.ORANGE, Color.CYAN,Color.MAGENTA,Color.YELLOW,Color.GRAY};
   
      public TextEditorGUI(){
      //Cargar archivo .conf
         Properties defaultSettings = new Properties();
         defaultSettings.put("width", "700");
         defaultSettings.put("height", "460");
         defaultSettings.put("port", "8889");
         defaultSettings.put("clients_max", "5");
         defaultSettings.put("server", "localhost");
         defaultSettings.put("username", "johndoe");
         int p1 = 0, p2 = 0;
         String p3 = "", p4 = "", p5 = "", p6 = "";
         try{
            FileInputStream in = new FileInputStream("TextEditorGUI.conf");
            Properties preferences = new Properties(defaultSettings);
            preferences.load(in);
            p1 = Integer.parseInt(preferences.getProperty("width"));
            p2 = Integer.parseInt(preferences.getProperty("height"));
            p3 = preferences.getProperty("port");
            p4 = preferences.getProperty("clients_max");
            p5 = preferences.getProperty("server");
            p6 = preferences.getProperty("username");
         }
            catch(Exception ex){
               System.out.println("(1)"+ex.toString());
               System.exit(-1);
            }
         final int width = p1;
         final int height = p2;
         final String port = p3;
         final String max = p4;
         final String server = p5;
         final String username = p6;
      //fin carga .conf
      
         this.setSize(width,height);
         this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
         this.setAlwaysOnTop(false);
         this.setTitle("EDITOR");
         final Image bgImage = (new ImageIcon("./images/background.png")).getImage();
         JPanel panel = 
            new JPanel(){
               public void paintComponent(Graphics g){
                  Dimension dim = this.getSize();
                  g.drawImage(bgImage,0,0,dim.width,dim.height,null);				
               }
            };
         panel.setLayout(new GridBagLayout());
         panel.setBorder(new EmptyBorder(10,10,10,10));
         JScrollPane scroller = new JScrollPane(panel);
         scroller.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
         scroller.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);		
      
      //Crear la barra de menu
         JMenuBar menubar = new JMenuBar();
      //Menu Archivo
         JMenu menuArchivo = new JMenu("Archivo");
         JMenuItem menuArchivoItem1 = new JMenuItem("Abrir");
         menuArchivoItem1.addActionListener(new menuAbrirListener());
         JMenuItem menuArchivoItem2 = new JMenuItem("Guardar");
         menuArchivoItem2.addActionListener(new menuGuardarListener());
         JMenuItem menuArchivoItem3 = new JMenuItem("About");
         menuArchivoItem3.addActionListener(
               new ActionListener(){
                  public void actionPerformed(ActionEvent event){
                     JOptionPane.showMessageDialog
                        (null,"Daniel Guzman Salazar\n2421025-1\n\nProgramacin de Sistemas.\nELO-330\n",
                        "About",JOptionPane.INFORMATION_MESSAGE);
                  }
               }
            );
         JMenuItem menuArchivoItem4 = new JMenuItem("Exit");
         menuArchivoItem4.addActionListener(
               new ActionListener(){
                  public void actionPerformed(ActionEvent event){
                     System.exit(0);
                  }
               }
            );
      //Menu conexion
         JMenu menuConexion = new JMenu("Conexion");
         JMenuItem menuConexionItem1 = new JMenuItem("Servidor");
         menuConexionItem1.addActionListener(
               new ActionListener(){
                  public void actionPerformed(ActionEvent event){
                     JPanel panel = new JPanel();
                     panel.setLayout(new BoxLayout(panel,BoxLayout.Y_AXIS));
                     JTextField tfield1 = new JTextField();	//por defecto, el valor del .conf
                     tfield1.setMaximumSize(new Dimension(80,50));
                     tfield1.setDocument(new JTextFieldLimit(5));
                     tfield1.setText(port);
                     JTextField tfield2 = new JTextField();	//por defecto, el valor del .conf
                     tfield2.setMaximumSize(new Dimension(25,50));
                     tfield2.setDocument(new JTextFieldLimit(1));
                     tfield2.setText(max);
                     panel.add(new JLabel("Puerto de recepcin:"));
                     panel.add(tfield1);
                     panel.add(new JLabel("N mximo de conexiones:"));
                     panel.add(tfield2);
                  
                     int o = JOptionPane.showConfirmDialog(null, panel, "Crear servidor", JOptionPane.OK_CANCEL_OPTION);		
                  
                     if(o == JOptionPane.OK_OPTION ){
                        Thread t = new MyServerThread(tfield1.getText(), tfield2.getText());
                        t.start();
                     }
                  
                  }
               }
            );
         JMenuItem menuConexionItem2 = new JMenuItem("Cliente");
         menuConexionItem2.addActionListener(
               new ActionListener(){
                  public void actionPerformed(ActionEvent event){
                     JPanel panel = new JPanel();
                     panel.setLayout(new BoxLayout(panel,BoxLayout.Y_AXIS));
                     JTextField tfield1 = new JTextField();	//por defecto, el valor del .conf
                     tfield1.setMaximumSize(new Dimension(400,50));
                     tfield1.setDocument(new JTextFieldLimit(25));
                     tfield1.setText(server);
                     JTextField tfield2 = new JTextField();	//por defecto, el valor del .conf
                     tfield2.setMaximumSize(new Dimension(120,50));
                     tfield2.setDocument(new JTextFieldLimit(5));
                     tfield2.setText(port);
                     JTextField tfield3 = new JTextField();	//por defecto, el valor del .conf
                     tfield3.setMaximumSize(new Dimension(160,50));
                     tfield3.setDocument(new JTextFieldLimit(10));
                     tfield3.setText(username);
                     panel.add(new JLabel("Direccion del servidor:"));
                     panel.add(tfield1);
                     panel.add(new JLabel("Puerto del servidor:"));
                     panel.add(tfield2);
                     panel.add(new JLabel("Nombre de usuario:"));
                     panel.add(tfield3);
                  
                     int o = JOptionPane.showConfirmDialog(null, panel, "Conexion a servidor", JOptionPane.OK_CANCEL_OPTION);
                  
                  
                     if(o == JOptionPane.OK_OPTION ){
                        Thread t = new MyClientThread(tfield1.getText(), tfield2.getText(), tfield3.getText());
                        t.start();
                     }
                  
                  }
               }
            );
         menuArchivo.add(menuArchivoItem1);
         menuArchivo.add(menuArchivoItem2);
         menuArchivo.add(menuArchivoItem3);
         menuArchivo.add(menuArchivoItem4);
         menuConexion.add(menuConexionItem1);
         menuConexion.add(menuConexionItem2);
      
      //Area de texto
         textArea = new MyTextPane();		
         JScrollPane scrollPane = new JScrollPane(textArea);
         scrollPane.getViewport().setBackground(Color.white);
         Dimension dim = new Dimension(590,600);
         scrollPane.setPreferredSize(dim);
         scrollPane.setMaximumSize(dim);
         scrollPane.setMinimumSize(dim);
         scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
         documentListener = new MyDocumentListener();
      //Indicador de fila y columna
         final JLabel cursorPosition = new JLabel("Linea:0 Columna:0");
         cursorPosition.setFont(new Font(null,Font.PLAIN, 11));
         cursorPosition.setMaximumSize(new Dimension(50,20));
         textArea.addCaretListener(
               new CaretListener(){
                  public void caretUpdate(CaretEvent ce){
                     Utilities utilities = new Utilities();
                     try{
                        Document doc = textArea.getDocument();
                        Element root = doc.getDefaultRootElement();
                        int dot = ce.getDot();
                        int line = root.getElementIndex( dot );
                        int column = dot - root.getElement( line ).getStartOffset();
                        cursorPosition.setText("Linea:"+line+" Columna:"+column);
                     }
                        catch(Exception e){
                           System.out.println("(2)"+e.toString());
                        }
                  }
               }
            );
      //Barra lateral
         sidebar = new JPanel();
         sidebar.setLayout(new BoxLayout(sidebar,BoxLayout.Y_AXIS));
         sidebar.setOpaque(false);
         JLabel lab1 = new JLabel("Estado de la conexion:");
         lab1.setSize(new Dimension(100,50));
         sidebar.add(lab1);
         JLabel lab2 = new JLabel("No conectado");
         lab2.setSize(new Dimension(50,50));
         sidebar.add(lab2);
         sidebar.add(new JSeparator());
         sidebar.add(new JSeparator());
         JLabel lab3 = new JLabel("Participantes:");
         lab3.setSize(new Dimension(100,50));
         sidebar.add(lab3);
      //Aadir el menu al frame	
         menubar.add(menuArchivo);
         menubar.add(menuConexion);
         this.setJMenuBar(menubar);
      //Se aade el area de texto al panel principal
         GridBagConstraints gbc = new GridBagConstraints();
         gbc.anchor = GridBagConstraints.NORTHWEST;
         gbc.gridx = 0;
         gbc.gridy = 1;
         gbc.weightx = 2;
         gbc.weighty = 2;
         gbc.gridwidth = 2;
         gbc.gridheight = 2;
         panel.add(scrollPane,gbc);
      //Se agrega la barra lateral
         gbc.gridx = 2;
         gbc.gridy = 0;
         gbc.gridwidth = 1;
         gbc.gridheight = 2;
         gbc.weightx = 0;
         gbc.weighty = 0;
         panel.add(sidebar,gbc);
      //Se agrega la posicion del cursor
         gbc.gridx = 0;
         gbc.gridy = 0;
         gbc.gridwidth = 2;
         gbc.gridheight = 1;
         panel.add(cursorPosition,gbc);
         this.add(scroller);
      
         this.setDefaultCloseOperation(EXIT_ON_CLOSE);
         this.setVisible(true);
      }
   /**
    * Mtodo que agrega el string entregado luego del ultimo caracter del area de texto.
    * @param str String a agregar.
    * @param position Posicion del string a agregar
    */	
      public static synchronized void addText(String str, int position, int client_index){
         try{
            if(position == -1)
               position = textArea.getStyledDocument().getLength();
         
         //SimpleAttributeSet attrs = new SimpleAttributeSet();
            MutableAttributeSet attrs = textArea.getInputAttributes();	
            StyleConstants.setForeground(attrs, colorArray[client_index]);			
            textArea.getStyledDocument().insertString(position, str, attrs);
         }
            catch(Exception e){}
      }
   /**
    * Mtodo que borra el caracter en la posicion indicada.
    * @param position Posicion del caracter a borrar.
    */	
      public static synchronized void removeText(int position, int length){
         try{
            if(position == -1)
               position = textArea.getStyledDocument().getLength();
            textArea.getStyledDocument().remove(position, length);
         }
            catch(Exception e){}
      }
   /**
    * Mtodo que retorna el Area de Texto.
    * @return El Area de Texto del editor.
    */
      public static JTextPane getTextArea(){
         return textArea;
      }
   /**
    * Escuchar por cambios en el texto
    */
      public static void documentListenerON(){
         textArea.getDocument().addDocumentListener(documentListener);
      }
   /**
    * No escuchar por cambios en el texto
    */
      public static void documentListenerOFF(){
         textArea.getDocument().removeDocumentListener(documentListener);
      }
   /**
    * Tipo de host: SERVER o CLIENT
    */
      public static void setHostType(String type, int client_index){
         hostType = type;
         sidebar.setVisible(false);
         JLabel label = new JLabel(type);
         label.setSize(new Dimension(100,50));
      //Sidebar tiene: 0->titulo, 1->estado actual
         sidebar.add(label,1);	//desplazar el anterior
         sidebar.remove(2);	//remover el anterior
         sidebar.setVisible(true);
      /*try{	//Escribir con los atributos del cliente asignado
      	MutableAttributeSet attrs = textArea.getInputAttributes();
      	//StyleConstants.setForeground(attrs, colorArray[client_index]);
      	StyledDocument doc = textArea.getStyledDocument();
      	doc.setCharacterAttributes(0, doc.getLength() + 1, attrs, false);
      }catch(Exception e){}
      */
      }
      public static synchronized void addInSidebar(String str, int client_index){
         sidebar.setVisible(false);
         JLabel label = new JLabel(str);
         label.setSize(new Dimension(100,50));
         label.setBorder(new LineBorder(colorArray[client_index], 2));
         if( hostType.compareTo("SERVER") == 0){
            final String username = str;
            final int cindex = client_index;
            label.addMouseListener(
                  new MouseListener(){
                     public void mouseClicked(MouseEvent e){
                        MyServerThread.disconnectClient(username, cindex);
                     }
                     public void mouseEntered(MouseEvent e){}
                     public void mouseExited(MouseEvent e){}
                     public void mousePressed(MouseEvent e){}
                     public void mouseReleased(MouseEvent e){}
                  }
               );
         }
         sidebar.add(label);
         sidebar.setVisible(true);
      }
      public static synchronized void removeFromSidebar(String str){
         try{
            sidebar.setVisible(false);
            int j=0;
            for( Component comp : sidebar.getComponents()){
               if(comp.getClass().toString().compareTo("class javax.swing.JLabel")==0){
                  if((str.compareTo("ALL")==0)&&(j>4)){
                     sidebar.remove(comp);
                  }
                  else
                     if(((JLabel)comp).getText().compareTo(str) ==0)
                        sidebar.remove(comp);
               }
               j++;
            }
            sidebar.setVisible(true);
         }
            catch(Exception e){}
      }
   /**
    * El mtodo principal del programa. Crea la instancia del editor de texto y lo inicia.
    * @param args Parmetros del programa ingresados por consola. Sin uso.
    */		
      public static void main(String[] args){
         TextEditorGUI c = new TextEditorGUI();
      }
   /**
    * Clase interna que implementa ActionListener para la accion 
    * asociada al boton Guardar del menu del editor de texto.
    * @author Daniel Guzman S.
    */	
      class menuGuardarListener implements ActionListener{
      /**
       * Mtodo implementado, definido en la interface ActionListener.
       * El presionar el boton Guardar del menu Archivo, se muestra una ventana de eleccin de directorio.
       * En el directorio seleccionado se crear un archivo con el texto del JTextPane.
       * Este mtodo se ejecuta automticamente al presionar el boton. 
       * @param e Objeto que contiene la informacion del evento.
       */
         public void actionPerformed(ActionEvent e) {
            try{
               JFileChooser chooser;
               int sobreescribir = JOptionPane.YES_OPTION;
               do{
                  chooser = new JFileChooser();//Buscar directorio donde guardar
               
               //En cancel, cerrar chooser
                  if( chooser.showSaveDialog(null) != JFileChooser.APPROVE_OPTION )
                     return;
               
               //Si existe el archivo, preguntar si sobreescribir
                  if( chooser.getSelectedFile().exists() ){
                     sobreescribir = JOptionPane.showConfirmDialog
                        (null,"Archivo ya existe.\nSobreescribir?", "Elige uno", JOptionPane.YES_NO_OPTION);
                  }					
               }while( sobreescribir != JOptionPane.YES_OPTION );
               setTitle(getTitle()+":"+chooser.getSelectedFile());
            //Asociar el Printer al archivo deseado en el directorio
               PrintWriter printer = new PrintWriter(new FileWriter(chooser.getSelectedFile()));
            
               printer.print(textArea.getText());//Se copia lo que est en el TextArea
               printer.close();
            
            }
               catch(IOException ex){//Capturar esta excepcion obligatoria
                  JOptionPane.showMessageDialog(null,"Error de escritura de archivo","Error",JOptionPane.ERROR_MESSAGE);
               }
         }
      }
   /**
    * Clase interna que implementa ActionListener para la accion 
    * asociada al boton Abrir del menu del editor de texto.
    * @author Daniel Guzman S.
    */	
      class menuAbrirListener implements ActionListener{
      /**
       * Mtodo implementado, definido en la interface ActionListener.
       * El presionar el boton Abrir del menu Archivo, se muestra una ventana de eleccin de directorio.
       * Se escoge un arhivo, idealmente de texto, que es desplegado en el JTextPane.
       * Este mtodo se ejecuta automticamente al presionar el boton. 
       * @param e Objeto que contiene la informacion del evento.
       */
         public void actionPerformed(ActionEvent e) {
            try{
               JFileChooser chooser;
            
               do{
                  chooser = new JFileChooser();//Buscar directorio donde guardar
               
               //En cancel, cerrar chooser
                  if( chooser.showOpenDialog(null) != JFileChooser.APPROVE_OPTION )
                     return;
               	
               }while( !chooser.getSelectedFile().exists() );
               setTitle(getTitle()+":"+chooser.getSelectedFile());	
            //Asociar el lector al archivo escogido
               BufferedReader in = new BufferedReader(new FileReader(chooser.getSelectedFile()));
            
               String str;
               textArea.setText("");
               while ((str = in.readLine()) != null) {
                  addText(str + "\n", -1, 0);
               }
               in.close();
            
            }
               catch(IOException ex){//Capturar esta excepcion obligatoria
                  JOptionPane.showMessageDialog(null,"Error de lectura de archivo","Error",JOptionPane.ERROR_MESSAGE);
               }
         }
      }
      class MyDocumentListener implements DocumentListener{
      
         public void changedUpdate(DocumentEvent e) {
         // text was changed
         //System.out.println("A");
         }
         public void removeUpdate(DocumentEvent e) {
         // text was deleted
            try{
               if(hostType == "CLIENT")
                  MyClientThread.sendToServer((char)0, e.getOffset(), e.getLength(), e.getType().toString());
            }
               catch(Exception ex){
                  System.out.println("(3)"+ex.toString());
               }
         }
         public void insertUpdate(DocumentEvent e) {
         // text was inserted
            try{
               String input = e.getDocument().getText(e.getOffset(),e.getLength());
               for(int i=0; i<e.getLength(); i++){
                  if(hostType == "CLIENT")
                     MyClientThread.sendToServer(input.charAt(i), e.getOffset()+i, 0, e.getType().toString());
               }
            }
               catch(Exception ex){
                  System.out.println("(4)"+ex.toString());
               }
         }
      }
   }